#patches_base=v1.4.0-rc1
Patch0001: 0001-rbd-detect-pools-associated-to-NVMe-device-class.patch
Patch0002: 0002-alua-reduce-the-debug-logs.patch
Patch0003: 0003-runner-rbd-update-lock-state-on-RTPG-INQUIRY.patch
Patch0004: 0004-Do-not-return-alua-state-transition.patch
Patch0005: 0005-tcmur-fix-the-initial-value-of-the-return-var.patch
Patch0006: 0006-runner-fix-double-close-free.patch
Patch0007: 0007-runner-fix-double-log-message.patch
Patch0008: 0008-runner-reopen-dev-right-away-if-we-know-we-had-the-l.patch
Patch0009: 0009-runner-rbd-do-not-set-lock-metadata-if-not-needed.patch
Patch0010: 0010-Add-newline-to-alua-lock-messages.patch
Patch0011: 0011-Change-alua-transition-in-process-message-to-a-debug.patch
Patch0012: 0012-runner-don-t-drop-iscsi-connection-on-lock-fence-err.patch

%global oversion 1.4.0-rc1

Name:		tcmu-runner
Version:	1.4.0
Release:	0.4%{?dist}
Summary:	A daemon that supports LIO userspace backends

Group:		System Environment/Daemons
License:	ASL 2.0
URL:		https://github.com/open-iscsi/tcmu-runner
Source0:	https://github.com/open-iscsi/${name}/archive/v%{oversion}/%{name}-v%{oversion}.tar.gz

Requires:	librbd1 >= 2:12.2.4
Requires:	targetcli >= 2.1.fb47-0.1

BuildRequires:	cmake
BuildRequires:	glib2-devel
BuildRequires:	kmod-devel
BuildRequires:	libnl3-devel
BuildRequires:	librbd1-devel >= 2:12.2.4
BuildRequires:	systemd-units

Obsoletes:	libtcmu

%description
A daemon that handles the complexity of the LIO kernel target's userspace
passthrough interface (TCMU). It presents a C plugin API for extension modules
that handle SCSI requests in ways not possible or suitable to be handled
by LIO's in-kernel backstores.

%prep
%autosetup -p1 -n %{name}-%{oversion}

%build
%cmake -DSUPPORT_SYSTEMD=ON -Dwith-glfs=false -Dwith-qcow=false .
make %{?_smp_mflags}
gzip --stdout tcmu-runner.8 > tcmu-runner.8.gz

%pre
if [ "$1" = "2" ]; then
  # RHEL kernel does not support runner restarting hung IO, so we must
  # stop rbd-target-gw to make sure running IO is completed and new IO
  # is not sent to us while runner is restarting.
  systemctl is-active --quiet rbd-target-gw && systemctl stop rbd-target-gw
  systemctl stop tcmu-runner
fi

%install
make install DESTDIR=%{buildroot}
mkdir -p %{buildroot}%{_mandir}/man8/
install -m 644 tcmu-runner.8.gz %{buildroot}%{_mandir}/man8/

%post
/sbin/ldconfig
systemctl daemon-reload
systemctl start tcmu-runner
systemctl is-enabled --quiet rbd-target-gw && systemctl start rbd-target-gw

%files
%{_bindir}/tcmu-runner
%{_libdir}/*
%{_libdir}/tcmu-runner/*
%{_sysconfdir}/dbus-1/system.d/tcmu-runner.conf
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/tcmu/tcmu.conf
%{_datarootdir}/dbus-1/system-services/org.kernel.TCMUService1.service
%{_unitdir}/tcmu-runner.service
%doc README.md
%license LICENSE
%{_mandir}/man8/tcmu-runner.8.gz

%changelog
* Tue Oct 02 2018 Jason Dillaman <dillaman@redhat.com> 1.4.0-0.4
- runner: don't drop iscsi connection on lock fence errors (rhbz#1623650)
- Change alua transition in process message to a debug (rhbz#1623650)
- Add newline to alua lock messages. (rhbz#1623650)
- runner/rbd: do not set lock metadata if not needed (rhbz#1623650)

* Fri Aug 31 2018 Jason Dillaman <dillaman@redhat.com> 1.4.0-0.3
- runner: reopen dev right away if we know we had the lock and lost it (rhbz#1623737)
- runner: fix double log message (rhbz#1623737)
- runner: fix double close/free (rhbz#1623737)
- tcmur:fix the initial value of the return var (rhbz#1623737)
- Do not return alua state transition (rhbz#1623737)
- runner/rbd: update lock state on RTPG/INQUIRY (rhbz#1623737)
- alua: reduce the debug logs (rhbz#1623737)

* Tue Aug 14 2018 Jason Dillaman <dillaman@redhat.com> 1.4.0-0.2
- rbd: detect pools associated to NVMe device class (rhbz#1508611)

* Sat May 5 2018 Jason Dillaman <dillaman@redhat.com> 1.4.0-0.1.0
- rebased to 1.4.0-rc1

* Fri Apr 27 2018 Jason Dillaman <dillaman@redhat.com> 1.3.0-3
- merged libtcmu into tcmu-runner package

* Thu Apr 26 2018 Jason Dillaman <dillaman@redhat.com> 1.3.0-2
- tcmur: fix ret value in tcmur_dev_update_size
- fix the condition of sleep in _tcmu_reopen_dev
- config: reset to default values after the options being set
- tcmu-runner: improve the logging always to get daemon's exit state
- glfs: reopen on connection lost
- configfs: remove null chars in the string readed from the sys files
- Set correct sense upon getting write to FULL zone
- Add installation action for file_zbc handler
- zbc: fix maximum number of open zones
- zbc: fix write emulation
- Fixed build procedure in README.
- logging: improve log details
- glfs: remove size checks in handler
- extra: Add make_runnerrpms.sh support
- handler: do not perform implicit transition if command not supported
- glfs: update the glfs config descritions and add usage of creation

* Thu Apr 26 2018 Jason Dillaman <dillaman@redhat.com> 1.3.0-1
- rebased to 1.3.0
- spec changes to not overwrite tcmu.conf
- spec changes to stop/start services before/after installation

* Thu Sep 28 2017 Jason Dillaman <dillaman@redhat.com> 1.3.0-0.4
- rebased to 1.3.0-rc4

* Sat Sep 09 2017 Jason Dillaman <dillaman@redhat.com> 1.3.0-0.2.4
- libtcmu: fix name check for nl commands

* Tue Sep 05 2017 Jason Dillaman <dillaman@redhat.com> 1.3.0-0.2.3
- libtcmu: move genl_unregister_family to teardown_netlink
- open_handlers: fix dlsym return
- rbd: try to remain cluster's osd op timeout default value
- libtcmu: handle error when netlink family group is not found
- log config: fix tcmu_conf_set_options
- config: fix the default log level in tcmu.conf
- logger: logdir path setting via Env variable 'TCMU_LOGDIR'
- logdir: make log dir configurable in tcmu.conf
- logdir: fix error when making recursion directories
- logdir: move tcmu_logdir_create to log file and make it globally
- logdir: make tcmu_log_dir as static
- README: update and add logger setting and system config sections
- tcmur: fixed possible uninitialized variable warning
- fbo: use get be helpers.
- file_optical: fix strict aliasing rules
- add byteshift helpers
- main: set TCMUR_DEV_FLAG_IS_OPEN on successfully added devices
- libtcmu: fix cfgstring len
- README: fix highlighting the targetcli command looks like a title
- log/file_output: fix and clean up the file output callout
- logdir: add tcmu_logdir_check helper support
- alua:fix untrack when implicit transition not success
- runner: user tcmu_xxx helpers instead of printf
- main: fix crash by --tcmu-log-dir/-l
- tcmu-runner: make the max open files setup as operational
- tcmu-runner: increase max open file descriptors limit
- alua: to make sure the device failover is supported when alau access type is Implicit
- tcmur: fix rhandler->lock NULL pointer dereference
- alua: add failover_is_supported helper support
- rbd: misc fixes
- rbd: Add timers check for cluster osd
- tcmu-runner:fix the exception return value for function tcmu_get_alua_grps()
- tcmu:double free tgt_port in tcmu_get_alua_grp
- tcmu:fix return data length of rtpg response data
- .gitignore: update .gitignore
- runner: add errno info in err logs
- rbd: fix defined but not used warning
- cmake: add -Werror for CFLAGS
- rbd:fix comment in tcmu_rbd_cfg_desc
- runner: scsi debug info convert to tcmu_dev_dbg_scsi_cmd()
- alua: fix enabled_port NULL pointer dereference
- tcmur/unmap_split: reduce the unmap split logs output
- runner: fix main failure path
- libtcmu: merge resources release code
- rbd: Add the header explicitly when needed

* Tue Aug 15 2017 Jason Dillaman <dillaman@redhat.com> 1.3.0-0.2.2
- Depend on librbd1 packages from epoch 2

* Tue Aug 15 2017 Jason Dillaman <dillaman@redhat.com> 1.3.0-0.2.1
- Restrict to x86_64 arch

* Tue Aug 15 2017 Jason Dillaman <dillaman@redhat.com> 1.3.0-0.2
- Rebased to 1.3.0 RC2

